--no srb2 mod is complete without a funni command
freeslot("MT_STRIKER", "S_STRIKEWARN", "sfx_ugbir")

sfxinfo[sfx_ugbir].caption = "a bomb has been planted (RUN!)"

states[S_STRIKEWARN] = {
    sprite = SPR_STAB,
    frame = A|FF_FULLBRIGHT,
    nextstate = S_STRIKEWARN
}




local pri = CONS_Printf

mobjinfo[MT_STRIKER] = {
    doomednum = -1,
    spawnhealth = 1,
    radius = mobjinfo[MT_VULTURE].radius,
    height = mobjinfo[MT_VULTURE].height,
	health = 10,
    flags = MF_NOCLIP|MF_NOCLIPTHING|MF_SOLID|MF_NOGRAVITY
}

local function SpawnBird(p, target)
    local bird = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_STRIKER)
    
    S_StartSound(target, sfx_ugbir, target.player)
    bird.sprite = SPR_VLTR
	bird.tics = 500*TICRATE
    bird.owner = p.mo
    bird.colorized = true
    bird.color = p.mo.color
    bird.target = target
    bird.scale = target.scale
    local warn = P_SpawnMobj(target.x, target.y, target.z, MT_OVERLAY)
    warn.target = target
    warn.state = S_STRIKEWARN
    return bird
end

local function P_HasCollided(mo1, mo2, functio)
    local distance = R_PointToDist2(mo1.x, mo1.y, mo2.x, mo2.y)
    local heightDiff = abs(mo1.z - mo2.z)

    if distance <= FixedMul(mo1.radius, max(mo1.momx, mo1.momy)/10) and heightDiff <= mo1.height then
        print(mo1.owner.player.name.."'s airstrike killed "..mo2.player.name.."!")
        functio(mo1, mo2)
        return true
    else
        return false
    end
end

local function BirdExplode(bird, target)
    P_SpawnRealExplosion(target)
    ErasePlayer(target.player)
    P_KillMobj(target, bird.owner)
    P_RemoveMobj(bird)
end

local function PartOfString(arg, str)
    if #arg == 1 then
        if #str == 1 then
            return string.lower(arg) == string.lower(str)
        else
            return false
        end
    end

    local index = 1
    for i = 1, #str do
        if string.sub(string.lower(str), i, i) == string.sub(string.lower(arg), index, index) then
            index = index + 1
            if index > #arg then
                return true
            end
        end
    end
    return false
end

local function FindPlayer(p, nam)
    for player in players.iterate do
        if (player and player.valid) and (player ~= p) and PartOfString(nam, player.name) then
            return player
        end
    end
    return nil
end

addHook("MobjThinker", function(bird)
    if bird and bird.valid then
		if not (bird.owner and bird.owner.valid)
			P_SpawnRealExplosion(bird)
			P_RemoveMobj(bird)
		end
	end
end, MT_STRIKER)



addHook("MobjThinker", function(bird)
    if bird and bird.valid then
        if bird.target == nil or (not bird.target.valid) then
            P_RemoveMobj(bird)
        else
            bird.tics = 10*TICRATE
            local bt = bird.target
            bird.z = bird.target.z
            bird.angle = R_PointToAngle2(bird.x, bird.y, bt.x, bt.y)
            local dist = R_PointToDist2(bird.x,bird.y,bt.x,bt.y)/5
            P_InstaThrust(bird, bird.angle, (dist/FU)*bird.scale + 24*bird.scale)
            local smoke = P_SpawnMobj(bird.x, bird.y, bird.z, MT_SMOKE)
            smoke.scale = bird.scale
            if P_HasCollided(bird, bird.target, BirdExplode) and bird and bird.valid then
                --print("collieded")
            end
        end
    end
end, MT_STRIKER)




addHook("MobjThinker", function(bird)
    if bird and bird.valid then
        if bird.target == nil then
            P_RemoveMobj(bird)
        end
    end
end, MT_STRIKER)

addHook("MobjThinker", function(o)
	if o and o.valid
		and o.state == S_STRIKEWARN
		and o.target.player.playerstate == PST_DEAD
		P_RemoveMobj(o)
	end
end, MT_OVERLAY)

COM_AddCommand("chasemyself", function(p, a)
    if not (p.mo and p.mo.valid) then 
        pri(p, "...you might wanna exist first") 
        return 
    end
    local bird = SpawnBird(p, p.mo)
    P_MoveOrigin(bird, 0, 0, 0)
end,1)

COM_AddCommand("airstrike", function(p, a)
    if not (p.mo and p.mo.valid) then 
        pri(p, "...you might wanna exist first") 
        return 
    end

    if not a then 
        pri(p, "the name of the player you wanna strike") 
        return 
    end

    if string.lower(a) == string.lower(p.name) then 
        pri(p, "you want to strike yourself? (if you do, use the chasemyself command)")
        return
    end

    local partname
    if a == "all" then
        -- If the input is "all", strike all players
        for player in players.iterate do
            if player and player.valid and player ~= p and player.mo and player.mo.valid then
                SpawnBird(p, player.mo)
            end
        end
        return
    elseif a == "0" then
        -- If the input is 0, use players[0]
        partname = players[0]
    elseif tonumber(a) then
        -- If the input is a number, use it as the player index
        local playerIndex = tonumber(a)
        if players[playerIndex] and players[playerIndex].valid then
            partname = players[playerIndex]
        end
    else
        -- If the input is not a number, use the FindPlayer function
        partname = FindPlayer(p, a)
    end

    if partname == nil then
        pri(p, "i dont think that player isnt real......")
        return
    end

    if partname.mo and partname.mo.valid then
        SpawnBird(p, partname.mo)
    else
        pri(p, "i dont think that player isnt real......")
    end
end, 1)