addHook("PlayerSpawn", function(p)
	p.uglyslam = 0
end)

freeslot("S_UGLY_POUND", "SPR2_UGGP", "S_UGLY_SLAM")


states[S_UGLY_SLAM] = {
	sprite = SPR_PLAY,
	frame = SPR2_SPIN|FF_ANIMATE,
	var1 = 3,
	var2 = 2,
	nextstate = S_UGLY_SLAM
}


states[S_UGLY_POUND] = {
	sprite = SPR_PLAY,
	frame = SPR2_UGGP|FF_ANIMATE,
	var1 = 2,
	var2 = 2,
	nextstate = S_UGLY_POUND
}
	



local function BounceShield(p)
	if p.powers[pw_shield] == SH_BUBBLEWRAP then return true end
	if p.powers[pw_shield] == SH_ELEMENTAL then return true end
	return false
end

local function PoundStates(p)
	local m = p.mo
	if m.state == S_UGLY_SLAM then return true end
	if m.state == S_UGLY_POUND then return true end
	return false
end


addHook("PlayerSpawn", function(p)
	p.moz = 17*FU
end)
local function P_NearGround(player)
	local playerZ = player.mo.z
	local p = player
	local floorZ = player.mo.floorz
		
	if p.mo.eflags & MFE_VERTICALFLIP
		floorZ = player.mo.ceilingz
	end

	if abs(playerZ - floorZ) <= 15*(abs(p.mo.momz)/10) and not p.hasAlreadyPrinted and p.uglyslam then--sometimes you can fall too fast and this wont detect it so that's why the "15*(abs(p.mo.momz)/10)" is there
		p.moz = p.uglyslam
		p.hasAlreadyPrinted = true
		--print("Down Slam MomZ is: "+p.moz/FU)
	elseif abs(playerZ - floorZ) > 15*(abs(p.mo.momz)/10) then
		p.hasAlreadyPrinted = false
	end
end


addHook("PlayerThink", P_NearGround)



addHook("PlayerThink", function(p)
	if p.uglyslam
		p.uglyslam = $ - 2*FU
	end
end)

addHook("PlayerThink", function(p)
	if p.uglystart
		p.uglystart = $ - 1
	end
end)




addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		and p.bspin
		and not (p.cmd.buttons & BT_SPIN)
		p.bspin = false
	end
end)

addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		if p.cmd.buttons & BT_SPIN and p.pflags & PF_JUMPED and not (p.pflags & PF_THOKKED) and not P_IsObjectOnGround(p.mo) and not p.coyoteTime
			p.uglyspinhold = $ + 1
			else
			p.uglyspinhold = 0
		end
	end
end)

addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		and p.sspin
		and not (p.cmd.buttons & BT_SPIN)
		p.sspin = false
	end
end)


rawset(_G, 'L_ZLaunch', function(mo,thrust,relative)--this function is also from clariebun (thx clariebun)
	if mo.eflags&MFE_UNDERWATER
		thrust = $*3/5
	end
	P_SetObjectMomZ(mo,thrust,relative)
end)


	



local function StartFall(p, state, start)
	local m = p.mo
	if P_IsObjectInGoop(p.mo) then return end
	p.pflags = $|PF_SPINNING
	p.pflags = $|PF_THOKKED
	m.state = state
	p.powers[pw_strong] = STR_FLOOR|STR_CEILING|STR_SPRING|STR_SPIKE|STR_HEAVY|STR_ANIM
	if not BounceShield(p)
		p.mo.momz = 0
		P_SetObjectMomZ(m, 20*FU, true)
	end
	S_StartSound(p.mo, sfx_zoom)
	if BounceShield(p)
		p.uglystart = 1
		P_SetObjectMomZ(m, start*FU)
		p.uglyslam = start*FU
	end
	p.uglystart = 5
end


addHook("PlayerThink", function(p)
	if p.uglystart == 1 and not BounceShield(p)
		P_SetObjectMomZ(p.mo, p.uglystart*FU, true)
		p.uglyslam = p.uglystart*FU
		p.uglystart = 0
	end
end)

local function EndFall(p)
	local m = p.mo
	if P_CheckDeathPitCollide(p.mo) then return end
	p.pflags = $ & ~PF_SPINNING
	p.pflags = $ & ~PF_THOKKED
	m.state = S_PLAY_FALL
	if not (P_CheckDeathPitCollide(p.mo))
		for i = 1,10 do
			local dust = P_SpawnMobjFromMobj(m, 0, 0, 0, MT_SPINDUST)
			
			dust.scale = m.scale
			dust.angle = FixedAngle(i*36*FU)
			P_InstaThrust(dust, dust.angle, 20*m.scale)
		end
	end
	if p.uglyslam <= -70*FU then
		P_NukeEnemies(m, m, 500*m.scale)
		S_StartSound(m, sfx_dmpain)
		else
		S_StartSound(m, sfx_pstop)
	end
	if (p.cmd.buttons & BT_JUMP) and not P_CheckDeathPitCollide(p.mo)
		p.bspin = true--jump
		p.sspin = true--spin
		S_StartSound(m, sfx_spring)
		local dah = abs(p.moz)*53/100
		if dah < 15*FU
			dah = 17*FU
		end
		--print(".-----------------------------------------")
		--print("New Momz is: "+dah/FU)
		L_ZLaunch(p.mo, dah)-- you might be thinking.... "AVERAGE YOU DUMMY! WHY NOT JUST USE p.uglyslam!?!?!?", well i DID try that BUT for some reason it divided by it's INITIAL (starting) amount :(
		----print(dah/FU)
		m.state = S_PLAY_ROLL
		p.pflags = $|PF_JUMPED
		p.pflags = $ & ~PF_SPINNING
		if not P_CheckDeathPitCollide(p.mo)
			m.state = S_PLAY_ROLL
		end
	end
	p.uglyslam = 0
end


	


addHook("MobjDamage", function(pmo)
	if pmo.skin == UG then
		pmo.player.uglyslam = 0
	end
end)

addHook("JumpSpinSpecial", function(p)
	if p.mo.skin == UG and (not BounceShield(p)) and p.uglyspinhold >= 4 and (p.bspin ~= true) and (not (p.pflags & PF_THOKKED))
		StartFall(p, S_UGLY_SLAM, -10)
	end
end)

addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		and p.mo.skin == UG
		and p.uglyslam
		and PoundStates(p)
		P_SpawnGhostMobj(p.mo)
		if p.mo.state == S_UGLY_POUND and leveltime%4 == 0
			CreateAfter(p)
		end
		P_SetObjectMomZ(p.mo, p.uglyslam, false)
	end
end)




addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		and p.mo.skin == UG
		and p.uglyslam
		and P_IsObjectOnGround(p.mo)
		EndFall(p)
	end
end)

addHook("ShieldSpecial", function(p)
	if p.mo and p.mo.valid
		and p.mo.skin == UG
		and BounceShield(p) then
		StartFall(p, S_UGLY_POUND, -45)
		p.powers[pw_strong] = STR_FLOOR|STR_CEILING|STR_SPRING|STR_SPIKE|STR_HEAVY|STR_ANIM
		return true
	end
end)
		
addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		and p.mo.skin == UG
		and p.uglyslam
		and p.mo.eflags & MFE_SPRUNG
		p.uglyslam = 0
	end
end)

addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		and p.mo.skin == UG
		and p.uglyslam
		and not (P_IsObjectOnGround(p.mo))
		and not PoundStates(p)
		p.uglyslam = 0
	end
end)

addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		and p.mo.skin == UG
		and p.uglyslam
		and PoundStates(p)
		and P_IsObjectInGoop(p.mo)
		p.uglyslam = 0
		p.mo.state = S_PLAY_ROLL
	end
end)
		
	
	