freeslot("S_UGLY_NAPPING", "SPR2_UGSL", "sfx_ugnap")

sfxinfo[sfx_ugnap].caption = "intense and fast snoring"

states[S_UGLY_NAPPING] = {
    sprite = SPR_PLAY,
    frame = SPR2_UGSL
}
uglystates[S_UGLY_NAPPING] = true

local function IsInStrings(str, ...)
    local args = {...}
    local lowerStr = string.lower(str)
    for _, v in ipairs(args) do
        if lowerStr == string.lower(v) then
            return true
        end
    end
    return false
end

local scaleValues = {
    FRACUNIT/2,
    FRACUNIT*5/8,
    FRACUNIT*3/4,
    FRACUNIT*7/8,
    FRACUNIT,
    FRACUNIT*9/8,
    FRACUNIT*5/4,
    FRACUNIT*11/8,
    FRACUNIT*3/2,
    FRACUNIT*11/8,
    FRACUNIT*5/4,
    FRACUNIT*9/8,
    FRACUNIT,
    FRACUNIT*7/8,
    FRACUNIT*3/4,
    FRACUNIT*5/8
}

addHook("PlayerMsg", function(p, _, _, msg)
    if p and p.valid
        and p.playerstate == PST_LIVE
        and p.mo.skin == UG
        and p.panim == PA_IDLE
        and IsInStrings(msg, "slumber", "tired", "zzz", "sleepy", "sleep", "slumbers", "doze", "forty winks", "hibernation", "nap", "shuteye", "siesta", "snooze", "zizz", "rest", "repose", "drowse", "kip", "catnapping", "coma", "snoozing", "dozing", "beauty sleep", "bye-byes", "few z's", "few zs" , "lie-down", "light sleep", "power nap", "sack time", "shut-eye", "a bit of shut-eye", "deep sleep", "bed", "relaxation", "inactivity", "idleness", "sleepiness", "somnolence", "stupor", "sleeping", "drowsing", "sedentariness", "restfulness", "stillness", "dreaminess", "afternoon sleep", "little sleep", "nod", "respite", "rack", "microsleep", "supineness", "some Zs", "twenty winks", "short sleep", "nana nap", "rack time", "land of nod", "beddy-bye", "resting", "slumbrous", "somnolent", "slumberous", "dozy", "asleep", "dull", "hypnotic", "slow", "drowsy", "tired", "exhausted", "lethargic", "half-asleep", "sluggish", "drained", "knackered", "heavy-eyed", "stupefied", "quiet", "peaceful", "tranquil", "uneventful", "unexciting", "boring", "lifeless", "comatose", "dopey", "draggy", "heavy", "out", "out of it", "sleepyhead", "slumberous", "slumbersome", "snoozy", "soporific", "torpid", "yawning", "worn out", "burned out", "wiped out", "dog-tired", "stonkered", "shattered", "overtired")
        S_StartSound(p.mo, sfx_ugnap)
        S_StopSoundByID(p.mo, sfx_ugyap)
        p.mo.state = S_UGLY_NAPPING
        p.currentScaleIndex = 1 -- Reset the scale index
        p.hasExecutedOnceForNonNapping = false -- Reset the flag
        S_StopSoundByID(p.mo, sfx_ugyap)
    end
end)

addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid
        and p.mo.skin == UG
        and p.mo.state ~= S_UGLY_NAPPING
        S_StopSoundByID(p.mo, sfx_ugnap)
        if p.hasExecutedOnceForNonNapping == false then
            p.mo.spriteyscale = FRACUNIT
			--print("executed")
            p.hasExecutedOnceForNonNapping = true
        end
    else
        p.hasExecutedOnceForNonNapping = false -- Reset the flag
    end
end)

addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid
        and p.mo.skin == UG
        and p.mo.state == S_UGLY_NAPPING
        if not S_SoundPlaying(p.mo, sfx_ugnap) then
            S_StartSound(p.mo, sfx_ugnap)
        end
        p.mo.spriteyscale = scaleValues[p.currentScaleIndex]
        p.currentScaleIndex = p.currentScaleIndex + 1
        if p.currentScaleIndex > #scaleValues then
            p.currentScaleIndex = 1
        end
    end
end)

addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid
        and p.mo.skin == UG
        and p.mo.state == S_UGLY_NAPPING
        and (p.rmomx ~= 0 or p.rmomy ~= 0)
        p.mo.state = S_PLAY_FALL
        p.mo.spriteyscale = FRACUNIT
    end
end)

addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid
        and p.mo.skin ~= UG
        and p.mo.state == S_UGLY_NAPPING
        p.mo.state = S_PLAY_FALL
        p.mo.spriteyscale = FRACUNIT
    end
end)