freeslot("MT_UGLY_SCREAM", "S_UGLY_SCREM")
local box = MT_UGLY_SCREAM
local damageAmount = 5 -- Variable to store the standalone 5

states[S_UGLY_SCREM] = {
	sprite = SPR_PLAY,
	frame = SPR2_GASP
}

mobjinfo[box] = {
    doomednum = -1,
    spawnhealth = 1,
    spawnstate = S_INVISIBLE,
    deathstate = S_NULL,
    xdeathstate = S_NULL,
    deathsound = sfx_null,
    radius = 1536*FRACUNIT,
    height = 75*FRACUNIT,
    flags = MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

rawset(_G, "L_InZ", function(mo, mo2)
    local zdist = abs(mo.z - mo2.z)
    if zdist <= 200*FU then
        return true
    else
        return false
    end
end)

local function P_SpawnScreamer(p)
    local m = p.mo
    local d = P_SpawnMobj(m.x, m.y, m.z, box)
    S_StartSound(p.mo, sfx_ugrah)
    p.powers[pw_shield] = SH_NONE
    p.mo.state = S_UGLY_SCREM
    d.target = p.mo
    d.tics = TICRATE
    return d
end

addHook("MobjThinker", function(bo)
    if bo and bo.valid and bo.type == box then
        if not (bo.target) then
            P_RemoveMobj(bo)
        elseif bo.target then
            local pmo = bo.target
            P_MoveOrigin(bo, pmo.x, pmo.y, pmo.z)
            bo.scale = pmo.scale
        end
    end
end, box)
addHook("MobjThinker", function(bo)
        if bo and bo.valid and bo.type == box then
            if not (bo.target) then
                P_RemoveMobj(bo)
            elseif bo.target then
                local pmo = bo.target
                P_MoveOrigin(bo, pmo.x, pmo.y, pmo.z)
                bo.scale = pmo.scale
            end
        end

end, box)

addHook("PlayerSpawn", function(p)
    p.bombscream = false
end)

addHook("PlayerThink", function(p)
    if p.bombtimer then
        p.bombtimer = p.bombtimer - 1
        p.pflags = p.pflags | PF_THOKKED
		p.pflags = $ & ~PF_SPINNING
    else
        if p.bombscream then
            p.bombscream = false
			p.mo.state = S_PLAY_WALK
        end
    end
end)

addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid and p.mo.skin == UG and p.bombscream and p.mo.state == S_UGLY_SCREM then
        p.mo.momx = 0
        p.mo.momy = 0
        p.mo.momz = 0
		P_StartQuake(50*FU, 1)
        local angle = p.drawangle
        local x = p.mo.x
        local y = p.mo.y
        local z = p.mo.z + p.mo.height / 2
       

        for i = 1, 20 do
            local spark = P_SpawnMobjFromMobj(p.mo,0, 0, p.mo.height / 2, MT_SUPERSPARK)
			spark.scale = p.mo.scale
            spark.angle = p.drawangle + FixedAngle(P_RandomRange(45,-45)*FU)
            P_SetObjectMomZ(spark, P_RandomRange(15,-15)*FU)
            P_InstaThrust(spark, spark.angle, 50*p.mo.scale)
        end
    end
end)

addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid and p.mo.skin == UG and p.coyoteTime == 0 and p.playerstate == PST_LIVE and p.powers[pw_shield] == SH_ARMAGEDDON and (not p.powers[pw_carry]) and p.cmd.buttons & BT_CUSTOM3 and (not (p.pflags & PF_THOKKED)) and not P_IsObjectOnGround(p.mo) and not p.bombscream then
        p.bombscream = true
        p.bombtimer = TICRATE
        P_SpawnScreamer(p)
    end
end)

local function PlayerScream(mo, mo2)
    if mo2 and mo2.valid
    and mo.target.player
    and mo.target.player.valid
    and (mo2.flags & MF_ENEMY or mo2.flags & MF_BOSS or ((G_FightGameMode() or (G_CoopGametype() and CV_FindVar("friendlyfire").value == 1)) and mo2.type == MT_PLAYER and mo2 ~= mo.target))
	and not (mo2.cantdam)
    and L_InZ(mo, mo2) then

        local enemy = mo2

        if mo.target.player.powers[pw_super] then
            damageAmount = 10
			else
			damageAmount = 5
        end

        if mo2.type ~= MT_PLAYER and mo2.health > damageAmount then
            P_DamageMobj(mo2, mo.target, mo.target, damageAmount)
			mo2.cantdam = TICRATE
        elseif mo2.type ~= MT_PLAYER and mo2.health <= damageAmount then
            local ragdoll = P_SpawnRagdoll(mo2)
            ragdoll.angle = enemy.angle
            enemy.flags = enemy.flags | MF2_DONTDRAW

            if enemy and enemy.valid then
                P_KillMobj(mo2, mo.target, mo.target)
                P_MoveOrigin(enemy, 999999*FU, 999999*FU, 999999*FU)
            end

            P_InstaThrust(ragdoll, R_PointToAngle2(ragdoll.x, ragdoll.y, mo.target.x, mo.target.y), -50 * FU)
            P_SetObjectMomZ(ragdoll, 20 * FU)
			
        elseif mo2.type == MT_PLAYER and mo2 ~= mo.target then
            P_DamageMobj(mo2, mo.target, mo.target, 1)
            P_InstaThrust(mo2, R_PointToAngle2(mo2.x, mo2.y, mo.target.x, mo.target.y), -50 * FU)
            P_SetObjectMomZ(mo2, 50 * FU)
			mo2.cantdam = TICRATE
        end
    end
end

addHook("MobjCollide", PlayerScream, box)
addHook("MobjMoveCollide", PlayerScream, box)


addHook("MobjThinker", function(mo2)
	if mo2.cantdam
		mo2.cantdam = $ - 1
	end
end)

addHook("MobjThinker", function(box)
	if box and box.valid
		and box.target and box.target.valid
		and box.target.state ~= S_UGLY_SCREM
		P_RemoveMobj(box)
	end
end, box)


addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid
        and p.mo.skin == UG
        and p.mo.state ~= S_UGLY_SCREM
        if p.makingthisbeccauseimbadatTracking == false then
           S_StopSoundByID(p.mo, sfx_ugrah)
            p.makingthisbeccauseimbadatTracking = true
        end
    else
        p.makingthisbeccauseimbadatTracking = false
    end
end)