--"STOP" -average April 21st, 2024. 5:32 PM EST

freeslot("SPR2_UGST", "sfx_ugsto", "S_UGLY_STOP")

states[S_UGLY_STOP] = {
	sprite = SPR_PLAY,
	frame = SPR2_UGST
}
	

sfxinfo[sfx_ugsto].caption = "STOP"

addHook("PlayerSpawn", function(p)
	p.t = {}
end)

local function Halt(p)
	local m = p.mo
	p.t = {
		sp = p.speed,
		d = p.dashmode,
		s = m.state,
		f = m.frame
	}
	S_StartSound(m, sfx_ugsto)
	m.state = S_UGLY_STOP
	local st = P_SpawnGhostMobj(m)
	st.scale = m.scale
	p.halttime = 5*TICRATE
	st.destscale = m.scale*2
end
		
local function Restore(p)
	local m = p.mo
	P_Thrust(m, m.angle, p.t.sp)
	p.speed = p.t.sp
	p.dashmode = p.t.d
	m.state = p.t.s 
	m.frame = p.t.f 
	p.halttime = 0
end 

addHook("PlayerThink", function(p)
	if p.halttime then
		p.halttime = $ - 1
	end
end)

addHook("ShieldSpecial", function(p)
	if p.mo and p.mo.valid
		and p.mo.skin == UG
		and p.powers[pw_shield] & SH_FORCE
		and p.mo.state ~= S_UGLY_STOP
		Halt(p)
	end
end)

addHook("ThinkFrame", function()
	for p in players.iterate do
		if p.mo and p.mo.valid
			and p.mo.skin == UG
			and p.mo.state == S_UGLY_STOP
			p.mo.momx = 0
			p.mo.momy = 0
			p.mo.momz = 0
			p.dashmode = p.t.d
		end
	end
end)

addHook("ThinkFrame", function()-- the best way to combat a thinkframe... is to USE... a thinkframe.....
	for p in players.iterate do
		if p.mo and p.mo.valid
			and p.mo.skin == UG
			and p.mo.state == S_UGLY_STOP
			and p.halttime == 0 then
			p.mo.state = S_PLAY_FALL
		end
	end
end)

addHook("ThinkFrame", function()
	for p in players.iterate do
		if p.mo and p.mo.valid
			and p.mo.skin == UG
			and p.mo.state == S_UGLY_STOP
			and not (p.cmd.buttons & BT_SPIN)
			Restore(p)
			p.speed = p.t.sp
		end
	end
end)