
freeslot("S_SUPSPARK", "sfx_ugrah")

sfxinfo[sfx_ugrah].caption = "RAAAAAAAHHHH"
sfxinfo[sfx_ugrah].flags = SF_X4AWAYSOUND


addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid then
        if p.powers[pw_super] then
			p.powers[pw_underwater] = 999
			p.powers[pw_spacetime] = 999--infinite oxygen
            if not p.superSoundPlayed then
				if p.mo.skin == UG
					S_StartSound(nil, sfx_ugrah)
					P_NukeEnemies(p.mo, p.mo, 1500*p.mo.scale)
				end
				p.superSoundPlayed = true
            end
        else
            p.superSoundPlayed = false
        end
    end
end)

addHook("PlayerSpawn", function(p)
    p.superTable = {}
    p.targetTable = {}
    p.gol = nil
end)


local hark = S_SUPSPARK

states[S_SUPSPARK] = {
    sprite = SPR_SSPK,
    frame = A|FF_ANIMATE,
    var1 = 2,
    var2 = 2,
    nextstate = S_SUPSPARK
}

freeslot("MT_SUPERDETECT")
local box = MT_SUPERDETECT




local function P_IsSparkTarget(mobj)
	if mobj.imindangerhelp == true or mobj.imatarget
		return true
	end
    return false
end

table.hasvalues = function(t)
    for _, v in pairs(t) do
        if v and v.valid and v.health ~= 0 then
            return true
        end
    end
    return false
end

addHook("MobjSpawn", function(mobj)
	mobj.imindangerhelp = false
end)



mobjinfo[box] = {
    doomednum = -1,
    spawnhealth = 1,
    spawnstate = S_INVISIBLE,
    deathstate = S_NULL,
    xdeathstate = S_NULL,
    deathsound = sfx_null,
    radius = 1000*FU,
    height = 70*FU,
    flags = MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

local function P_SpawnSuperDetect(p)
	local m = p.mo
	local d = P_SpawnMobj(m.x, m.y, m.z, box)
	d.target = p.mo
end

addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid and p.mo.skin == UG and p.powers[pw_super] then
		local m = p.mo
        if not p.spawnedBox then
            P_SpawnSuperDetect(p)
            p.superTable = p.superTable or {}
            p.targetTable = p.targetTable or {}
            if not (p.gol and p.gol.valid) then
                p.gol = P_SpawnMobj(m.x, m.y, m.z, MT_OVERLAY)
                p.gol.target = p.mo
                p.gol.sprite = SPR_PLAY
                p.gol.skin = m.skin
                p.gol.angle = p.drawangle
                p.gol.sprite2 = m.sprite2
                p.gol.state = p.mo.state
            end
            p.spawnedBox = true
        end
    else
        p.spawnedBox = false
    end
end)

addHook("MobjThinker", function(bo)
    if bo and bo.valid and bo.type == box then
        if not (bo.target) then
            P_RemoveMobj(bo)
        elseif bo.target then
            local pmo = bo.target
            P_MoveOrigin(bo, pmo.x, pmo.y, pmo.z)
            bo.scale = pmo.scale
        end
    end
end, box)

addHook("MobjThinker", function(bo)
        if bo and bo.valid and bo.target and bo.target.player and bo.type == box and bo.target.valid then
			local pmo = bo.target
			if (not pmo.player.powers[pw_super]) or pmo.skin ~= UG
				P_RemoveMobj(bo)
			end
		end
end, box)
           
local function P_SpawnSuperSparks(player)
    local mo = player.mo
    local angle = 0
    local radius = 128 * player.mo.scale
    local superTable = player.superTable or {}

    if player.powers[pw_super] and player and player.valid and mo and mo.valid and mo.skin == UG then
        if not table.hasvalues(superTable) then
            for i = 1, 8 do
                local x = FixedMul(radius, cos(angle))
                local y = FixedMul(radius, sin(angle))
                local spark = P_SpawnMobjFromMobj(mo, x, y, 0, MT_SUPERSPARK)
				
                spark.angle = angle
                spark.radius = radius
                spark.p = player
                spark.rollangle = player.mo.rollangle
                spark.scale = mo.scale
                spark.colorized = true
                spark.state = hark
                spark.target = nil
                spark.height = 20 * FU
                spark.radius = 20 * FU
                spark.flags = MF_NOCLIPHEIGHT | MF_NOGRAVITY
                spark.color = mo.color
                angle = angle + ANGLE_45
                spark.angle = angle
                table.insert(superTable, spark)
            end
        end
    else
        if player.mo.skin ~= UG or (not player.powers[pw_super] and table.hasvalues(superTable)) then
            for i, spark in ipairs(superTable) do
                if spark.valid then
                    P_RemoveMobj(spark)
                end
                table.remove(superTable, i)
                break
            end
        end
    end

    player.superTable = superTable
end



addHook("PlayerThink", function(player)
    if player.powers[pw_super] and not table.hasvalues(player.superTable) then
        P_SpawnSuperSparks(player)
    end
end)

addHook("MobjThinker", function(s)
    if s and s.valid and s.target == nil and s.state == hark then
        local angle = s.angle
        local radius = 150*s.p.mo.scale
        local player = s.p
		local pmo = s.p.mo
		s.tics = 999*TICRATE --i dont want it to vanish?!?!?! ok!?!??!!?
        local x = FixedMul(radius, cos(angle))
        local y = FixedMul(radius, sin(angle))
		local z = pmo.z
		if pmo.eflags & MFE_VERTICALFLIP
			z = pmo.z + pmo.height
		else
			z = pmo.z
		end
        P_MoveOrigin(s, player.mo.x + x, player.mo.y + y, z)
        s.angle = $ + FixedAngle(6*FU)
		s.scale = player.mo.scale
		s.color = player.mo.color
		s.rollangle = player.mo.rollangle
		if pmo.eflags & MFE_VERTICALFLIP
			s.eflags = $|MFE_VERTICALFLIP
		else
			s.eflags = $ & ~MFE_VERTICALFLIP
		end
		local guh = P_SpawnGhostMobj(s)
		guh.tics = 4
    end
end, MT_SUPERSPARK)


addHook("MobjThinker", function(s)
    if s and s.valid and s.target == nil and s.state == hark then
        local player = s.p
        local index = tableIndex(player.superTable, s)
        if (not player.powers[pw_super] or player.mo.skin ~= UG) and s.target == nil and index then
            table.remove(player.superTable, index)
            P_RemoveMobj(s)
        end
    end
end, MT_SUPERSPARK)

addHook("ThinkFrame", function()
    for p in players.iterate do
        if p.mo and p.mo.valid and p.mo.skin == UG and p.powers[pw_super] then
            local m = p.mo
            if not ((p.gol and p.gol.valid) or p.gol == nil) then
                p.gol = P_SpawnMobj(m.x, m.y, m.z, MT_OVERLAY)
                p.gol.target = p.mo
                p.gol.sprite = SPR_PLAY
                p.gol.skin = m.skin
                p.gol.angle = p.drawangle
                p.gol.sprite2 = m.sprite2
                p.gol.state = p.mo.state
            else
                local ia = p.gol
                local gho = P_SpawnGhostMobj(m)
                gho.scale = m.scale
                gho.colorized = true
                gho.skin = m.skin
                gho.frame = m.frame
                gho.sprite = SPR_PLAY
                gho.sprite2 = m.sprite2
                gho.tics = 3
                gho.destscale = m.scale * 6 / 5
                if p.gol and p.gol.valid then
                    p.gol.frame = m.frame
                    p.gol.colorized = true
                    ia.skin = m.skin
                    p.gol.angle = p.drawangle
                    p.gol.angle = p.drawangle
                    p.gol.sprite2 = m.sprite2
                    if m.flags2 & MF2_DONTDRAW then
                        ia.flags2 = $ | MF2_DONTDRAW
					else
						ia.flags2 = $ & ~MF2_DONTDRAW
                    end
                    ia.frame = m.frame
                    p.gol.spritexscale = m.spritexscale
					p.gol.rollangle = m.rollangle
                    p.gol.spriteyscale = m.spriteyscale
                    p.gol.dispoffset = p.mo.dispoffset + 30
                    p.gol.color = p.mo.color
                end
            end
        elseif (p.mo.skin ~= UG or not p.powers[pw_super]) and (p.gol and p.gol.valid) then
            P_RemoveMobj(p.gol)
			p.gol = nil
        end
    end
end)


local function EnemyDetect(mo, mo2)
    if mo2 and mo2.valid
        and mo.target.player
        and mo.target.player.valid
        and mo.target.player.powers[pw_super]
        and (mo2.flags & MF_ENEMY or mo2.flags & MF_BOSS or ((G_FightGameMode() or (G_CoopGametype() and CV_FindVar("friendlyfire").value == 1)) and mo2.type == MT_PLAYER and mo2 ~= mo.target))
        and L_ZCollide(mo, mo2) then
        local superTable = mo.target.player.superTable
        local targetTable = mo.target.player.targetTable
        if not tableIndex(targetTable, mo2) then
            if mo2.health ~= 0 and #targetTable < #superTable and not P_IsSparkTarget(mo2) then
                table.insert(targetTable, mo2)
            end
            mo2.imatarget = 2 -- Set imatarget to 2 regardless of other conditions
        else
            mo2.imatarget = 2 -- Keep imatarget as 2 if mo2 is already in targetTable
        end
    end
end
addHook("MobjThinker", function(s)
    if s and s.valid and s.imatarget
		if s.imatarget then
			s.imatarget = $ - 1
		end
	end
end)

addHook("MobjCollide", EnemyDetect, box)
addHook("MobjMoveCollide", EnemyDetect, box)

local function SparkKill(mo, mo2)
    if mo2 ~= mo.target then return end
	if not (mo and mo.valid) then return end
	if not L_ZCollide(mo, mo2) then return end
    P_DamageMobj(mo2, mo, mo.p.mo, 5)
	if mo2.type == MT_PLAYER
		print(mo.p.name+"'s super spark hit "+mo2.player.name+"!")
		P_KillMobj(mo2, mo, mo.p.mo)
		P_InstaThrust(mo2, mo2.player.drawangle, -70*FU)
	end
	mo.target = nil
	P_RemoveMobj(mo)
	mo2.imindangerhelp = false
end

addHook("MobjCollide", SparkKill, MT_SUPERSPARK)
addHook("MobjMoveCollide", SparkKill, MT_SUPERSPARK)

addHook("PlayerThink", function(p)
	if not p.targetTable
			p.targetTable = {}
		end
    if p.mo and p.mo.valid and p.mo.skin == UG
		and not (p.callcool)
		for i = 1,#p.targetTable do
			local e = p.targetTable[i]
			if e and e.valid
				and e.health ~= 0
				and e.health > 0
				P_SpawnLockOn(p, e, S_LOCKON1)
				if e.imatarget == 0
					table.remove(p.targetTable, tableIndex(p.targetTable, e))
				end
			end
		end
	end
end)

addHook("MobjThinker", function(s)
    if s and s.valid and s.imalone then
		if s.target and s.target.valid
			local guh = P_SpawnGhostMobj(s)
			guh.tics = 4
			s.tics = 999*TICRATE--im svared
			local st = s.target
			s.angle = R_PointToAngle2(s.x, s.y, st.x, st.y)
			if not (s.x == st.x and s.y == st.y)
				P_InstaThrust(s, s.angle, 60*FU)
			end
			local zdist = abs(s.z - st.z)
			if s.z > st.z then
				P_SetObjectMomZ(s, -zdist/4)
				elseif s.z < st.z
				P_SetObjectMomZ(s, zdist/4)
			end
			else
			P_RemoveMobj(s)
		end
	end
end, MT_SUPERSPARK)
			

addHook("PlayerThink", function(p)
    if p.callcool then
        p.callcool = p.callcool - 1
    end
    if p.mo and p.mo.valid and p.mo.skin == UG and p.cmd.buttons & BT_CUSTOM2 and p.powers[pw_super] and (not p.callcool) and table.hasvalues(p.targetTable) then
        local targetTableCount = #p.targetTable
        local sparksSpawned = 0
        for i = 1, targetTableCount do
            local sp = p.superTable[i]
            local tar = p.targetTable[i]
            if sp and tar then
                sp.target = tar
                sp.imalone = true
				sp.flags = $|MF_SOLID
                table.remove(p.superTable, i)
                table.remove(p.targetTable, i)
				tar.imindangerhelp = true
                sparksSpawned = sparksSpawned + 1
            end
        end
        if sparksSpawned >= targetTableCount then
            p.callcool = TICRATE*1/2
        end
    end
end)
addHook("MobjThinker", function(s)
    if s and s.valid and s.imalone and s.target and s.target.valid
		s.target.imindangerhelp = true
	end
end, MT_SUPERSPARK)

addHook("MobjThinker", function(s)
    if s and s.valid and s.imalone
		if s.nocliptimer then
			s.nocliptimer = $ - 1
			s.flags = $|MF_NOCLIP
		else
			s.flags = $ & ~MF_NOCLIP
		end
	end
end, MT_SUPERSPARK)
addHook("MobjMoveBlocked", function(s)
	if s and s.valid and s.imalone
		s.nocliptimer = 2
	end
end, MT_SUPERSPARK)


addHook("MobjRemoved", function(s)
	if s.target and s.target.valid
		s.imindangerhelp = false
	end
end, MT_SUPERSPARK)

addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid and p.mo.skin == UG and not p.powers[pw_super] then
        p.targetTable = {}
    end
end)