addHook("PlayerSpawn", function(p)
    p.uglyspawnthing = 10
	p.anotheruglything = false
    p.finishspawn = false
    p.isSpawningIn = false  -- Initialize the tracking variable
end)

local TRANSTABLE = {
    [0] = FF_TRANS10,
	[1] = FF_TRANS10,
    [2] = FF_TRANS20,
    [3] = FF_TRANS30,
    [4] = FF_TRANS40,
    [5] = FF_TRANS50,
    [6] = FF_TRANS60,
    [7] = FF_TRANS70,
    [8] = FF_TRANS80,
    [9] = FF_TRANS90,
	[10] = FF_TRANS90
}

addHook("PlayerSpawn", function(p)
    if p.mo and p.mo.valid
		and p.mo.skin == UG
		and (p.panim == PA_IDLE)
        local appear = P_RandomChance(FU/10) --10% chance to do the secret spawn
        if appear == true then
            if p.mo.skin == UG then
                p.uglyspawnthing = 10
                p.appear = 1*TICRATE
                p.anotheruglything = false
                p.mo.state = S_PLAY_STND
                p.saveframe = p.mo.frame
                p.isSpawningIn = true  -- Set to true when the spawn animation starts
            end
        end
    end
end)

addHook("PlayerThink", function(p)
    if p.panim == PA_IDLE then
        if p.appear then
            p.appear = $ - 1
            p.pflags = $|PF_FULLSTASIS
            p.mo.flags2 = $|MF2_DONTDRAW
            p.isSpawningIn = true  -- Ensure it's true during the appear phase
        else
            if p.anotheruglything == false and p.finishspawn ~= true then
                p.anotheruglything = true
            end
        end
    end
end)
addHook("PlayerThink", function(p)
    if p.mo.skin ~= UG then
        p.anotheruglything = false
        p.finishspawn = true
        p.isSpawningIn = false  -- Reset when skin is not UG
        return  -- Exit the function early for non-UG skins
    end
    
    if p.anotheruglything == true then
        if p.uglyspawnthing > 0 and p.isSpawningIn then  -- Changed from > 1 to > 0
            if leveltime%2 == 0 then
                p.uglyspawnthing = $ - 1
            end
            
            p.pflags = $|PF_FULLSTASIS
            p.mo.frame = TRANSTABLE[p.uglyspawnthing]
            p.isSpawningIn = true  -- Still spawning in during this phase
        else
            if p.finishspawn ~= true then  -- Removed the p.uglyspawnthing < 1 check
                p.finishspawn = true
                p.mo.flags2 = $ & ~MF2_DONTDRAW
                p.mo.frame = $ & ~FF_TRANS10
                p.isSpawningIn = false  -- Spawn animation is complete
            end
        end
    end
end) 